int led = 13;      // num. del pin conectado al LED integrado
int val = -1;
int cuenta = 0;
int BT_estado = 0;  // Variable del estado en que se encuentra el Bluetooth
                    //  0 = Modo inicializacion <modo comando>
                    //  1 = Modo Esperando_a_que_se_conecten (emparejar y/o establecer conexion) <modo comando>
                    //  2 = Modo Conectado <modo stream>
int num_ordenes = 0;
String orden;
int tam_indice = 0;

int freeRam () 
{
  extern int __heap_start, *__brkval; 
  int v; 
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
}

void vaciadoBuffer3()
{
  delay(2000);
  vacia_buffer_serial3();
}

void setup()
{
  Serial.begin(9600);
  Serial1.begin(9600,SERIAL_7O2);
  Serial3.begin(115200);
  pinMode(36,OUTPUT);
  pinMode(38,INPUT);
  //Serial.println("Iniciando Configuracion");
  pinMode(led,OUTPUT);
  digitalWrite(led, HIGH);
  
  vacia_buffer_serial();
  vacia_buffer_serial3();
  /* Se envia la secuencia para sacarla del modo "Stream" para segurarse de
     que aceptara los comandos (modo comando) */
  BT_soft_reset();
  delay(2000);
  vacia_buffer_serial3();
  if(BT_soft_reset()!=0)
  {
    // Si entra, es que esta en modo stream y hay que sacarlo
    while (BT_soft_reset() != 0 && BT_cancela_modo_Stream() != 0)
    {
      //Serial.println(" ");
      vacia_buffer_serial3();
    }
    while (BT_soft_reset!=0)
      vaciadoBuffer3();
  }
  while(BT_pon_modo_seguridad_1()!=0)
    vaciadoBuffer3();
  delay(1000);
  while(BT_visible()!=0)
    vaciadoBuffer3();
  delay(500);
  while(BT_modo_puerto_serie_canal1()!=0)
    vaciadoBuffer3();
  delay(500);
  while(BT_acepta_conexion_automatica()!=0)
    vaciadoBuffer3();
  delay(2000);
  BT_estado = 1;    // Ahora hay que esperar a que alguien se conecte
  //Serial.println("Esperando a una conexion");
}

void loop()
{
  digitalWrite(led,LOW);
  while(BT_estado==1)
  {
    // Ahora hay que esperar a que alguien se conecte
    while(BT_espera_conexion()!=0)
      vacia_buffer_serial3();
    while(BT_activa_modo_stream()!=0)
      vaciadoBuffer3();
    delay(200);
    //Serial.print("BT_estado = ");
    //Serial.println(BT_estado);
    delay(2000);
  }
  digitalWrite(led, HIGH);
  //Serial.println("Conectado");
  Serial3.print("Y");
  while(BT_estado==2)
  {
    int BTByte = getMessageSerial3();
    if(BTByte!=-1)
    {
      //Serial.println(BTByte);
      if(BTByte==35)
      {
        BT_estado = 1;  
        break;
      }
      else
        sendMessageSerial1(BTByte);
    }
    digitalWrite(36,0);
    int RBByte = getMessageSerial1();
    digitalWrite(36,1);
    if(RBByte!=-1)
    {
      //Serial.println(RBByte);
      sendMessageSerial3(RBByte);
    }
  }
}
