
int BT_soft_reset() 
{
    int valor_tmp;
    //Serial.println(" ");
    //Serial.print(" BT_soft_reset ............      => ");
    Serial3.print("AT+JRES \r\n");               // Software RESet
    valor_tmp = wait_for_ROK_timeout(5000);      // Espera por respuesta ROK
    return valor_tmp;
}

int BT_pon_modo_seguridad_1()
{
  int valor_tmp;
  //Serial.println(" ");
  vacia_buffer_serial3();
  //Serial.print(" BT_pon_modo_seguridad    ....   => ");
  Serial3.print("AT+JSEC=1,1,1,04,8714\r\n");    // Establece el modo de seg. 1
                                                 // pone el num. 8714 como clave
  valor_tmp = wait_for_OK();                     // Espera por respuesta OK
  return valor_tmp;
}

int BT_visible()
{
  int valor_tmp;
  //Serial.println(" ");
  vacia_buffer_serial3();
  //Serial.print(" BT_visible   .........          => ");
  Serial3.print("AT+JDIS=3\r\n");                // DIScoverable = 3 "Inquiry & Page Scan Enable"
  valor_tmp = wait_for_OK();                     // Espera por respuesta OK
  return valor_tmp;
}

int BT_modo_puerto_serie_canal1()
{  
  int valor_tmp;
  //Serial.println(" ");
  vacia_buffer_serial3();
  //Serial.print(" BT_modo_puerto_serie_canal1 ... => ");
  Serial3.print("AT+JRLS=1101,11,Serial Port,01,000000\r\n");
                                                 // Register Local Service
                                                 // 1101 = Serial port profile
                                                 // 11 = length of service name (dec)
                                                 // name
                                                 // Channel = 01
                                                 // Class of Device = 000000 (valor por defecto)
  valor_tmp = wait_for_OK();                     // Espera por respuesta OK
  return valor_tmp;
}
                      
int BT_acepta_conexion_automatica()
{
   int valor_tmp;
   //Serial.println(" ");
   vacia_buffer_serial3();
   //Serial.print(" BT_acepta_conexion_automatica   => ");
   Serial3.print("AT+JAAC=1\r\n");               // Auto Accept Connection requests
                                                 // 1 => eBMU will automatically auto accept
                                                 // incoming connection request – (host will be
                                                 // notified but connection is accepted automatically)
  valor_tmp = wait_for_OK();                     // Espera por respuesta OK
  return valor_tmp;
}

int BT_activa_modo_stream()
{
  int valor_tmp;
  //Serial.println(" ");
  vacia_buffer_serial3();
  //(" BT_activa_modo_stream  .......  => ");
  Serial3.print("AT+JSCR\r\n");                  // Stream Connection Request
                                                 // Activa la conexion transparente bidireccional
  valor_tmp = wait_for_OK_timeout(2000);         // Espera por respuesta OK
  return valor_tmp;
}


int BT_cancela_modo_Stream() 
{
    int valor_tmp;
    //Serial.println(" ");
    vacia_buffer_serial3();
    //Serial.print("BT_cancela_modo_stream .............   => ");
    delay(4000);                                 // T0 > 1 seg.
    Serial3.write("^");                          // Secuencia de cancelacion del Modo Stream
    //Serial.write("^");                           // Mostrarlo en pantalla...
    delay(1000);                                 // T1 = 1 seg.
    Serial3.write("^");                          // Secuencia de cancelacion del Modo Stream
    //Serial.write("^");                           // Mostrarlo en pantalla...
    delay(1000);                                 // T1 = 1 seg.
    Serial3.write("^");                          // Secuencia de cancelacion del Modo Stream
    //Serial.write("^");                           // Mostrarlo en pantalla...
    delay(4000);                                 // T0 > 1 seg.
    valor_tmp = wait_for_OK_timeout(4000);       // Espera por respuesta OK
    return valor_tmp;
}
